#!/usr/bin/env python
# -*- coding: utf-8 -*-

#TracLightning用
#プロジェクト名がxxxなら
#python svnlogadd.py xxx
#として実行、そのあとリビジョンをたずねてくるのでリビジョン番号の数字を入力
import sqlite3  # SQLiteの利用
import re
import sys
import os

#TL_PROJECT_HOMEが定義されてないならインストール先のprojectsを使う
tmp_project = os.getenv('PYTHONHOME','C:\\TracLight\\python')
tmp_project = tmp_project.rstrip('python')+'projects'

#「python svnlogadd.py xxx」ならxxxがsys.argv[1]に入る
project = os.getenv('TL_PROJECT_HOME',tmp_project) + '\\trac\\' + sys.argv[1] + '\\db\\trac.db' 
db = sqlite3.connect(project)  # データベースに接続
cur = db.cursor() #カーソルを作る
revs = raw_input('input revision: ')
##プレースホルダを使ってrevstrを代入しようとすると何故か「Incorrect number of bindings supplied.」となるので
##(revstr,)を代入してみたら何故かうまくいった(みんなのPython p.405参照)
##()内の「,」の数はデータが一つでも必ず一つ必要なのかも
##↓テーブルがあるか確認してみる
#cur.execute("SELECT name FROM sqlite_master WHERE type='table' UNION ALL SELECT name FROM sqlite_temp_master WHERE type='table' ORDER BY name")
#print cur.fetchall()
for rev, time, author, message in cur.execute('SELECT rev,time,author,message FROM revision WHERE rev = ?',(revs,)):
    #print "rev:%s" % (rev.encode('s-jis'))
    #print "message:%s" % (message.encode('s-jis'))
    pos=0
    while 1:
        pos=message.find('#',pos) #'#'の位置を探す
        if pos==-1:
            #print "end"
            break
        else:
            pos += 1 #次の位置から数字がいくつ続くか調べる
            #print pos
            cnt=pos+1 #最初は1文字調べる
            while message[cnt-1:cnt].isdigit():
                cnt += 1 #範囲が全て数字なら一文字増やす
            if cnt!= pos+1:
                ticket = message[pos:cnt-1] #「cnt += 1」により、1つ大きくなっているので-1している
                #print "ticket:%s" % (ticket.encode('s-jis'))
                
                #SQLに変数を直接埋め込まない,?の部分（プレースホルダ）が第二引数以降（バインド変数）で置き換えられる。
                #その際、変数がSQLの特殊文字を含んでいても普通の文字として扱われる。
                cur.execute('SELECT oldvalue FROM ticket_change WHERE ticket=? AND field="comment"',(ticket,)) #oldvalueはtextなのでsqlでmax()をとってはいけない
                ovalue=cur.fetchall()
                #print ovalue #タプルのリストになっている
                #print ovalue[0][0] #最初のタプルの、最初のデータを取り出す
                tmp = 0
                for ovaltmp in ovalue:
                    tmp = max(int(ovaltmp[0]),tmp)
                oldvalue = str(tmp + 1) #+1して利用する
                message2 = '(In [' + rev + ']) ' + message
                cur.execute('insert into ticket_change(ticket,time,author,field,oldvalue,newvalue) values (?,?,?,?,?,?)',(ticket,time,author,"comment",oldvalue,message2))
db.commit()   # データの保存
db.close()    # データベースの切断
